/* $Id: about.c,v 1.2 2000/01/10 16:29:15 rsmith Exp $
 * This file is a general about-box message for GTK+, adapted for xplanets.
 * Copyright (C) 2000  R.F. Smith
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You can contact the author at the following addresses:
 *     e-mail: rsmith@xs4all.nl
 * snail-mail: R.F. Smith
 *             Dr. Hermansweg 36
 *             5624 HR Eindhoven
 *             The Netherlands
 *
 * $Log: about.c,v $
 * Revision 1.2  2000/01/10 16:29:15  rsmith
 * Added description to About dialog.
 *
 * Revision 1.1  2000/01/05 21:38:36  rsmith
 * Initial revision
 *
 */

#include <gtk/gtk.h>
#include "about.h"

/*************** EXPORTS **************/ 
GtkWidget *about_btn;            /* Button that launches about box. */

/* Callback that is called when the `About' button is clicked.  */
void about_clicked (GtkWidget *widget, gpointer *data);

/************ STATIC DATA *************/
/* XPM */
static char *face_xpm[] = {
/* columns rows colors chars-per-pixel */
"51 80 20 1",
"  c #2e2018",
". c #4a342a",
"X c #644a3b",
"o c #715a4d",
"O c #ad776b",
"+ c #956c5e",
"@ c #c97370",
"# c #b38877",
"$ c #988473",
"% c #ca897b",
"& c #b39e8d",
"* c #ce9688",
"= c #daada0",
"- c #d6c8b8",
"; c #d9d6c7",
": c #e9dacd",
"> c #ece5d6",
", c #fbfaf6",
"< c #e4dce1",
"1 c #dc7d82",
/* pixels */
";;-;;;;;;;;;;;;;;;;;;;;;;;;;;;;;-;-;-;--;--------&-",
"-;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;-;;;-;-------&--",
";;;-;;;;;;;;;;;;;;;;;;;;;;;;-;;;-;-;;-;;-;----&;-&-",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;-;-;--------",
";;;;;;;;:;:;;;;;;;:;;;:;;-;;;;;;;;;;;;-;;;;-;----&-",
";;;;;;>;;>;;:;>;:;:;:;;;;;;;:;;;;;;;;;;;;;;;-;;----",
";>;:;:;>;;>;>;;;:;;---;;;;;;-----;;;;;;;;;;;;--;---",
";:;>;>;>;>;<;>;>;&&$&$&-;;;-&$&&&;;;;;;;;;;;;;;----",
":;>;;>;>;;<;<;;&&oo.X.oo&;-$$ooo$$&>;;;;;;;;;;;;---",
">;<;>;>;>;<>;;&$o.    ..X&&o.ooX.Xo&>;;;<;;;;;;;-;-",
":>;>;<;><;>;;&o.         ooX. .. ...$;>;>;<;;;;;;;-",
">;>;>>;>;>>;-o               ......  X;>>;<;;;;;;-;",
">>;>;>;>;>>-o        .         ...... X->>;<<;;;;;;",
";>><>>;>>>;o.                   .. ... .;>>>;<;;;;;",
">>;>;>><;,&.        .....        . . .. X;>;>;>;;;;",
">>>>>>;>>-o       .ooo$o$$ooXX   ...   . &>>;>;>;;;",
">>;>;>>>>$..     o$$$$$##$#$+ooX... .  . .&,>>;>>;:",
">><>>>;>-.o    o$$O$##%##%##$$$oooX.    . .&>>;>;::",
">>>>>;>>$.o.  o&#*&%%%%%%%%#%OO++ooX..   ...;>>;>:;",
">>>;>><;o.o. $******=%=%*%%%%%O#O+ooX.   .. $>>>:::",
">>>>>>>;X.X.$====*=*%%%=%%=%%%%#OO++oX    . o>>;>::",
">>>;><<&X..o===%==%=%==%=%%**%%%@O+++Xo   ...>>::::",
">>>>;><&X..$;-=%==%=%=%**=%%=%%%@O++O++.   . ->>:>;",
">>;>><;$Xoo&>====%=%=%=**%=%%%%%%O@OO++o   . &>>:::",
">>>>>><$ooo->-==%===%=%*=***%%%%%OOOOO++.    $,;>::",
">,>>>><&$oo->:=====%=%=****%=%%%%%@%@OOO.    X>>>:>",
">>>>>><&oo$>,=========%=%*=%*%%%%%%##%#OX    .;>;>:",
">,>><<<;$$$,>:========***%=*%=%=*%%%%%#O+  ..o;>>:>",
",>>,>>,-o$&,>:=-===%=%*****%*%%%*=%%#%#O+.  .$>>>>:",
",>,><<<;$o-,>:=%%%###%%%%%*%%%#####*#**#+.  .->>>:>",
",>,>,,,;$o;-&##$++oXX+OO%%##$++oo+++++##OX  o>>>>>:",
",,,>,<,<$o$-:-##$+++O++%%%%##+oXXXXo++++OX  +,>>:>>",
",>,,>,>,$$-;;=*%%%#%##+O#%#O+o+O+++#&=&-#X  &>>>>>>",
",,,>,,,,&$;>:-=%##$O+##.##+X.X+$++O&====&+oo;,>>>>>",
",,,,>,>:&&<,>=&#$$ooo+#+=%%+X++XX++$*&==&o.o>>>>>>>",
",,>,,:=*&->,--=$ XooXo$$==O+XoX.XXX+&&O&%XX#,>,>>>>",
",,,,>*@=&&,>-=&#.oo+Xo++%*%+X+X.X. X+oO&*+o+#%>>,>>",
",,,,=@*=-=,:::-##++$o+$$=*%OX+Xo+oXo+O$#*$+@O+%,>>>",
",,,,*@1==>:;-:==&###$$=#-=%%++++++O&&-##&#+%@++>>,>",
",,,,1@*==,::-==#+$%=%-=-:=%%++#&$$+&%&O*=#+%@@+>,>>",
",,,,1@@=%>>-==*%#*===-:-:=%%%+#%##O+O*#*##%%@@+:>,>",
",,,,=@%*%,>:==%@*=====:=:=%@#++#&###OOO*%%@@@X@,>,>",
",,,,>@@*@,,:==%%****=-=:==%@OO+OO%***O*%O*@@@X=,>,>",
",,,,,*@@@,,:===*@11===::-*%%@O+O#OOO@%O@%@+@@@:,,>>",
",,,,,:@1%,,:===*****=::>:=%%%@+@O%O@%@@%%%+@X@>>,,>",
",,,,,>1@-,,::==*****=>>>:=%%O%@+@%*%%*@%@@X@+=,,,>,",
",,,,,,:*=,,::==***%@*:1O==*@+O@+@#%**@%%@%@@X:,>,,>",
",,,,,,<=*,,<===**%1*%1**==@@+o++O@%**%%@@@@+1>,,,,,",
",,,,,,,:*:<<:==1@%%=====1@O++++@+@@%*%@@#@@@:,,,>,>",
",,,,,,,<=:,::==%@@====*1OOOO@+@+++%%*%%O@@@=,,,,,,,",
",,,,,,,,,<,::=%@%*====**OOOO+++O+OOO%*%%O*:,,>,,>,>",
",,,,,,,,,,,::=%#*=::-===OOO%@@@OOOOO%%%#O:,>,,,,,>,",
",,,,,,,,,,,>:=##%-::===11*@OOO#@#O###%#O#,,,,,,,>,,",
",,,,,,,,,,,>:=##OX+1=1*@O+OOOO++o+#O###$#,,>,,>,,,,",
",,,,,,,,,,,>>=*#+X +**===***OOX. XOO*##+=,,,,,,,>,,",
",,,,,,,,,,,>>-*OO1*%*OO**%O+oXXX+O+#*##+;,,,,>,,,,,",
",,,,,,,,,,,,>:*++=><:=@@+++++++@@++###+$,,,<,,,,>,,",
",,,,,,,,,,,>>:*++=>,<=@@+@+@++@O+++###+=,,,,,<,,,,,",
",,,,,,,,,,,,>:=$+&:,:=11@@@@@@@++++$$+$<,,,,,,,,,>,",
",,,,,,,,,,,,>>-##--:<==1@@@@@OO++++#$+$,,,,,,,,,,,,",
",,,,,,,,,,,,,:>==-=:==1#OOOOOO++++$$$+&,,,,,,,,,,,,",
",,,,,,,,,,,,,>>:-:====1OOOOOO++++$++$+-,,,,,,,,,,,,",
",,,,,,,,,,,,,>>::-:==1#O+++OO++O+++$+$-,,,,,,,,,,,,",
",,,,,,,,,,,,,,::::-:==&##@O@+OO+++$+$+<,,,,,,,,,,,,",
",,,,,,,,,,,,,,>::<:=--1##&@O+O+O+$+$+$>,,,,,,,,,,,,",
",,,,,,,,,,,,,,>::<::=-=1&1#$O+O++$++#+,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,>::::===#####O$$++++$$$,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,>:--=<=1###O$O$++++$+#$,,,,,,,,,,,,,",
",,,,,,,,,,;<,,,>>>-===&O##$O$+++++$##+:,,,,,,,,,,,,",
",,,,,,<,,;&,<,,,>>:-=*$++$O+++++++#+##-,,,,,,,,,,,,",
",,>;-&<,:--,;<,>>>>:-=&##$++++++$####+&-,,,,,,,,,,,",
";-&&->,>-$;,<<,,>:::-=*&$O$+++++####O#&$&,,,,,,,,,,",
"=&&;,,,-&&,,,&,,>:::-=&#$$$$O+$###%#+#=$o-,,,,,,,,,",
"&&=:,,--#-,,,&;,>:::--=####O$$###%%+$&&$X$&&;<,,,,,",
"&&&-,>-&#-,,,;&,>::::==&$##&##%%###+#%&#oo&&&&&-<,,",
"&=&-,&-&$;,,,,$=>:=::-=&#&*&**%&#%o$%&&&oXo&&$&$&;>",
"&&&->&;=$;,,,,=o=--=:===*****&%%%$+#&&&&$oo$&#&$$$&",
"&&#->&-=$:,,,,>$+=-==-==*=&*&%%#$X#&&&&#$oo$#&#&++$",
"#&#-;$;=&>,,,,,=X#%=====&**=*%#$o$%&&&&&$Xo$$##$$+$",
"###&;&--&;,,,,,=+$%*====&=&&%&#+o##&&#&#+oo$$$#$$++"
};

/********** STATIC FUNCTIONS **********/
static GtkWidget *about_win;    /* About box window */

/* Adds a line of text to the about box.  */
static void add_line(GtkWidget *box, char *text);

/* Callback that is called to destroy the about window.  */
static void delete_about (GtkWidget *widget, gpointer *data);

/*********** IMPLEMENTATION ***********/
void 
add_line(GtkWidget *box, char *text)
{
  GtkWidget *label = gtk_label_new(text);

  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 0);
}

void 
delete_about (GtkWidget *widget, gpointer *data)
{
  gtk_widget_destroy(about_win);
  about_win = NULL;
  gtk_widget_set_sensitive(GTK_WIDGET(about_btn), TRUE);
}

void 
about_clicked (GtkWidget *widget, gpointer *data)
{
  GtkWidget *hbox, *vbox, *vbox2, *button;
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GtkStyle *style;
  GdkBitmap *mask;

  /* prevent multiple about dialogs :-) */
  gtk_widget_set_sensitive(about_btn, FALSE);
  /* create the `about' window */
  about_win = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_position(GTK_WINDOW(about_win), GTK_WIN_POS_CENTER);
  gtk_window_set_title(GTK_WINDOW(about_win), "About "PROGRAM);
  gtk_window_set_wmclass(GTK_WINDOW(about_win), "about", PROGRAM); 
  gtk_container_border_width(GTK_CONTAINER(about_win), 5);
  gtk_widget_realize(about_win);
  gtk_signal_connect (GTK_OBJECT(about_win), "delete_event", 
                      GTK_SIGNAL_FUNC(delete_about), NULL);
  /* create a vbox, holding a hbox and some labels */
  vbox = gtk_vbox_new(FALSE, 4);
  gtk_container_add(GTK_CONTAINER(about_win), vbox);
  /* create a hbox, put in the pixmap and a vbox containing two lines */
  hbox = gtk_hbox_new(FALSE, 4);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  style = gtk_widget_get_style(about_win);
  pixmap = gdk_pixmap_create_from_xpm_d(about_win->window, &mask,
                                        &style->bg[GTK_STATE_NORMAL],
                                        (gchar **)face_xpm);
  pixmapwid = gtk_pixmap_new(pixmap, mask);
  gtk_widget_show(pixmapwid);
  vbox2 = gtk_vbox_new(FALSE, 4);
  add_line(vbox2, PROGRAM" "VERSION);
  add_line(vbox2, "a simple solar system simulator");
  add_line(vbox2, "Copyright (C) "OWNER);
  gtk_box_pack_start(GTK_BOX(hbox), vbox2, TRUE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), pixmapwid, FALSE, FALSE, 0);
  gtk_widget_show(vbox2);
  /* labels to go into the vbox */
  add_line(vbox, "This program is free software; "\
           "you can redistribute it and/or modify it");
  add_line(vbox, "under the terms of the GNU General Public License "\
           "as published by");
  add_line(vbox, "the Free Software Foundation; "\
           "either version 2 of the License, or");
  add_line(vbox, "(at your option) any later version.");
  add_line(vbox, "");
  add_line(vbox, "This program is distributed in the hope "\
           "that it will be useful, but");
  add_line(vbox, "WITHOUT ANY WARRANTY; without even the implied warranty of");
  add_line(vbox, "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.");
  add_line(vbox, "See the GNU General Public License for more details.");
  button = gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT(button), "clicked", 
                      GTK_SIGNAL_FUNC(delete_about), NULL);
  /* Show the windows */
  gtk_widget_show(button);
  gtk_widget_show(vbox);
  gtk_widget_show(hbox);
  gtk_widget_show(about_win);
}
